package rocks.zipcode.quiz5.collections;

import rocks.zipcode.quiz5.objectorientation.Spice;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author leon on 27/12/2018.
 */
public class Food {
    List<Spice> spices = new ArrayList<>();

    public List<Spice> getAllSpices() {
        return spices;
    }

    public <SpiceType extends Class<? extends Spice>> Map<SpiceType, Integer> getSpiceCount() {
        Map<SpiceType, Integer> hashMap = new HashMap<>();
        for (Spice spice : spices) {
            if (!hashMap.containsKey(spice.getClass())) {
                hashMap.put((SpiceType) spice.getClass(), 1);
            } else {
                hashMap.put((SpiceType) spice.getClass(), hashMap.get(spice.getClass()) + 1);
            }
        }
        return hashMap;
    }

    public void applySpice(Spice spice) {
        spices.add(spice);
    }
}
