package rocks.zipcode.quiz5.fundamentals;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        return string.charAt(string.length()/2);
    }

    public static String capitalizeMiddleCharacter(String str) {
        StringBuilder sb = new StringBuilder(str);
        int index = str.length() / 2;
        Character middleChar = Character.toUpperCase(StringUtils.getMiddleCharacter(str));
        sb.deleteCharAt(index);
        sb.insert(index, middleChar);
        return sb.toString();
    }

    public static String lowerCaseMiddleCharacter(String str) {
        StringBuilder sb = new StringBuilder(str);
        int index = str.length() / 2;
        Character middleChar = Character.toLowerCase(StringUtils.getMiddleCharacter(str));
        sb.deleteCharAt(index);
        sb.insert(index, middleChar);
        return sb.toString();
    }

    public static Boolean isIsogram(String str) {
        for (int i = 0; i < str.length(); i++) {
            String letter = String.valueOf(str.charAt(i));
            if (str.substring(i + 1).contains(letter)) {
                return false;
            }
        }
        return true;
    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {
        for (int i = 0; i < str.length() - 1; i++) {
            if (str.charAt(i) == str.charAt(i + 1)) {
                return true;
            }
        }
        return false;
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < str.length() - 1; i++) {
            if (str.charAt(i) == str.charAt(i + 1)) {
                i++;
            } else {
                sb.append(str.charAt(i));
            }
        }
        sb.append(str.charAt(str.length() - 1));
        return sb.toString();
    }

    public static String invertCasing(String str) {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < str.length(); i++) {
            if (Character.isUpperCase(str.charAt(i))) {
                sb.append(Character.toLowerCase(str.charAt(i)));
            } else {
                sb.append(Character.toUpperCase(str.charAt(i)));
            }
        }
        return sb.toString();
    }
}